#include <iostream>
#include <fitsio.h>
#include "../Utils.hh"

int main()
{

  float version;
  fits_get_version(&version);
  std::cerr << "Version no." << version << std::endl;

  fitsfile *fptr;
  int status = 0;
  char *template_file = (char *)getPSRFITSdefn().c_str();
  std::cerr << "opening with template...";
//   fits_create_template(&fptr, "!test.fits", getPSRFITSdefn().c_str(),&status);
//    fits_create_template(&fptr, "!test.fits", "/DATA/SITAR_1/whi550/ObsData/cubes/simulated/gaussianPlusOne.fits",&status);
//   fits_create_template(&fptr, "!test.fits", "psrheader.txt",&status);
  fits_create_template(&fptr, "!test.fits", "simpletemplate.fits",&status);
//   fits_create_file(&fptr, "!test.fits(simpletemplate.fits)",&status);
  //fits_create_template(&fptr, "!test.fits", "simpletabletemplate.fits",&status);
  if(status) fits_report_error(stderr, status);
  std::cerr << "done.\n";

  /*
 Use the following form, taken from 
 /pulsar/psr/cvshome/pulsar/soft_swin/psrchive/psrfits/FITSArchive.C
 which has the note  that they are equivalent to fits_create_template 
 except they don't cause segfaults.
  */

//   std::cerr << "opening...";
//   status = 0;
//   fits_create_file(&fptr, "!test.fits", &status);
//   if(status) fits_report_error(stderr, status);
//   std::cerr << "done.\n\n";

//   std::cerr << "doing template...";
//   status = 0;
//   //  fits_execute_template(fptr, getPSRFITSdefn().c_str(),&status);
//    fits_execute_template(fptr, template_file, &status);
// //   fits_execute_template(fptr, "psrheader.txt", &status);
// //  fits_execute_template(fptr, "/DATA/SITAR_1/whi550/ObsData/cubes/simulated/gaussianPlusOne.fits", &status);
// //   fits_execute_template(fptr, "simpletemplate.fits", &status);
//   if(status) fits_report_error(stderr, status);
//   std::cerr << "done.\n\n";

//   std::cerr << "moving to 1st hdu...";
//   status = 0;
//   fits_movabs_hdu(fptr, 1, 0, &status);
//   if(status) fits_report_error(stderr, status);
//   std::cerr << "done.\n\n";

  std::cerr << "closing...";
  status = 0;
  fits_close_file(fptr, &status);
  if (status){
    fits_report_error(stderr, status);
  }
  std::cerr << "done.\n";

}
